library cat_facts;

import 'dart:async';
import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:http/http.dart' as http;

class CatFact extends StatefulWidget {
  const CatFact({Key? key}) : super(key: key);

  @override
  State<CatFact> createState() => _CatFactState();
}

class _CatFactState extends State<CatFact> {
  String factText = '';

  void _getFactText() {
    var fact = _fetchFact();

    fact.then(
      (value) {
        setState(() {
          factText = value.fact;
        });
      },
    );
  }

  @override
  void initState() {
    _getFactText();
    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: () {
        _getFactText();
      },
      child: Container(
        margin: EdgeInsets.symmetric(vertical: 20, horizontal: 20),
        child: Center(
          child: Text(
            factText,
            style: TextStyle(
              fontSize: 24,
            ),
          ),
        ),
      ),
    );
  }
}

Future<Response> _fetchFact() async {
  final response = await http.get(Uri.parse('https://catfact.ninja/fact'));

  if (response.statusCode == 200) {
    return Response.fromJson(jsonDecode(response.body));
  } else {
    throw Exception('Failed to load album');
  }
}

class Response {
  final String fact;
  final int length;

  const Response({
    required this.fact,
    required this.length,
  });

  factory Response.fromJson(Map<String, dynamic> json) {
    return Response(
      fact: json['fact'],
      length: json['length'],
    );
  }
}
